<script type="text/javascript">
    RED.nodes.registerType('xkeys_trackball',{
        category: 'Xkeys',
        color: '#5dc8f4',
        defaults: {
            newname: {value:"X-keys Trackball"},
            name: {value:""},
			device: {value:""},
			productid: {value:"",
				validate:function(v){
					return v==""?true:(999 < parseInt(v) && parseInt(v) < 10000);
				}
			},
			pid_list: {value:"[]"},
			unit_id: {value:"",
				validate:function(v){
					return v==""?true:(-1 < parseInt(v) && parseInt(v) < 256);
				}
			},
			duplicate_id: {value:"",
				validate:function(v){
					return v==""?true:(-1 < parseInt(v) && parseInt(v) < 256);
				}
			},
			controller_id: {value:"",
				validate:function(v){
					return v==""?true:(-1 < parseInt(v));
				}
			},
        },
        inputs:0,
        outputs:1,
        icon: "X-keysXicon.png",
        label: function() {
            return this.name||this.newname||"X-keys Trackball";
        },
		labelStyle: function () {
			return this.newname?"node_label_italic":"";
		},
		paletteLabel: "xk trackball",
		oneditprepare: function() {
			var device_options = [];
			device_options.push({ value: "Any X-keys", label: "Press Deploy button to see device list"});
			$.getJSON('xkeys_trackball/products', function(product_data) {
				var devs = Object.keys(product_data);
				if (devs.length !== 0) {
					for (var d in devs) {
						if (devs.hasOwnProperty(d)) {
							device_options.push({ label: product_data[devs[d]].name, value:  devs[d]});
						}
					}
				}
				if (device_options.length > 1) {
					// Replace suggestion to deploy flow
					device_options[0] = { value: "Any X-keys", label: "Any X-keys"};
				}
				$("#node-input-device").typedInput({
					types: [{
						value: "device",
						options: device_options
					}]
				});
				if ($("#node-input-device").val() == "Any X-keys") {
					$("#node-input-productid").attr("placeholder", "Any");
				} else {
					$("#node-input-productid").attr("placeholder", "Auto");
				}
				$("#node-input-productid").on('change', function(ev, evtype, value) {
					// If productid is deleted (becomes Auto),
					// reset pid_list to whatever device is currently selected
					if ($("#node-input-productid").val().length == 0) {
						//var current_device = $("#node-input-device").val();
						set_pid_list($("#node-input-device").val());
					}
				});
				$("#node-input-device").on('change', function(ev, evtype, value) {
					set_pid_list(value);
				});
				/*
				*	Setup pid_list for a given device
				*/
				function set_pid_list (devicenam) {
					if (devs.includes(devicenam)) {
						// Collect the possible PIDs
						var hidDevs = [];
						product_data[devicenam].hidDevices.forEach(function(product_id) {
							hidDevs.push(product_id[0]);
						})
						// Save the pid_list for later matching with attached devices
						$("#node-input-pid_list").val(JSON.stringify(hidDevs));
						$("#node-input-productid").attr("placeholder", "Auto");
						$("#node-input-productid").val("");
					} else if (devicenam == "Any X-keys") {
						$("#node-input-pid_list").val(JSON.stringify([]));
						$("#node-input-productid").attr("placeholder", "Any");
						$("#node-input-productid").val("");
					} else {
						console.log("Unknown device selected");
					}
				};	// End of set_pid_list(devicenam)
			})
		},
		oneditsave: function () {
			// Construct label based on configured options
			this.newname = $("#node-input-device").typedInput("value");
			var duplicate_id = $("#node-input-duplicate_id").val();
			var unit_id = $("#node-input-unit_id").val();
			var controller_id = $("#node-input-controller_id").val();
			if (unit_id) {
				this.newname += " (" + unit_id + ")" + " Trackball";
			} else {
				this.newname += " Trackball";
			}
			if (controller_id) {
				this.newname += " " + controller_id;
			}
			// Handle case when productid was specified
			var productid = $("#node-input-productid").val();
			if (productid) {
				var pid_list = [];
				pid_list.push(parseInt(productid));
				$("#node-input-pid_list").val(JSON.stringify(pid_list));
			}
		}
    });
</script>

<script type="text/html" data-template-name="xkeys_trackball">
	<div class="form-row">
		<label for="node-input-device"><i class="fa fa-keyboard-o"></i> Device</label>
		<input type="text" id="node-input-device" placeholder="Device">
	</div>
	<div class="form-row">
		<label for="node-input-productid"><i class="fa fa-info"></i> Product ID</label>
		<input type="text" id="node-input-productid" placeholder="Any">
	</div>
	<div class="form-row">
		<label for="node-input-unit_id"><i class="fa fa-info-circle"></i> Unit ID</label>
		<input type="text" id="node-input-unit_id" placeholder="Any">
	</div>
	<div class="form-row">
		<label for="node-input-duplicate_id"><i class="fa fa-list-ol"></i> Duplicate ID</label>
		<input type="text" id="node-input-duplicate_id" placeholder="Any">
	</div>
	<div class="form-row">
	<div class="form-row">
		<label for="node-input-controller_id"><i class="fa fa-square-o"></i> Controller #</label>
		<input type="text" id="node-input-controller_id" placeholder="All">
	</div>
    <div class="form-row">
        <label for="node-input-name"><i class="fa fa-tag"></i> Label</label>
        <input type="text" id="node-input-name" placeholder="Auto">
    </div>
    <div class="form-row">
        <input type="hidden" id="node-input-pid_list">
    </div>
</script>



<!-- HELP -->
<script type="text/html" data-help-name="xkeys_trackball">
	<p>A node to process xkeys trackball events</p>
</script>
